<?php
/*----------------------------------------------------------------------------------|  www.vdm.io  |----/
				Lmskaran 
/-------------------------------------------------------------------------------------------------------/

	@version		1.0.91
	@build			8th May, 2023
	@created		22nd July, 2020
	@package		Moojla
	@subpackage		moojla_course_completed_restriction.php
	@author			Lmskaran <https://Lmskaran.com>	
	@copyright		Copyright (C) 2015. All Rights Reserved
	@license		GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
  ____  _____  _____  __  __  __      __       ___  _____  __  __  ____  _____  _  _  ____  _  _  ____ 
 (_  _)(  _  )(  _  )(  \/  )(  )    /__\     / __)(  _  )(  \/  )(  _ \(  _  )( \( )( ___)( \( )(_  _)
.-_)(   )(_)(  )(_)(  )    (  )(__  /(__)\   ( (__  )(_)(  )    (  )___/ )(_)(  )  (  )__)  )  (   )(  
\____) (_____)(_____)(_/\/\_)(____)(__)(__)   \___)(_____)(_/\/\_)(__)  (_____)(_)\_)(____)(_)\_) (__) 

/------------------------------------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');


/***[JCBGUI.joomla_plugin.head.108.$$$$]***/
use Joomla\CMS\Application\CMSApplication;
use Joomla\CMS\Plugin\CMSPlugin;


if(defined('HIKASHOP_COMPONENT')) {
    require_once( dirname(__FILE__).DS.'moojla_course_completed_restriction_class.php' );
}/***[/JCBGUI$$$$]***/


/***[JCBGUI.class_extends.comment.1.$$$$]***/
/**
 * Hikashop - Moojla_course_completed_restriction plugin.
 *
 * @package   Moojla_course_completed_restriction
 * @since     1.0.0
 *//***[/JCBGUI$$$$]***/

class PlgHikashopMoojla_course_completed_restriction extends CMSPlugin
{

/***[JCBGUI.joomla_plugin.main_class_code.108.$$$$]***/
	public function onFieldsLoad(&$fields, &$options) {

		$me = new stdClass();
		$me->name = 'moojla_course_completed_restriction';
		$me->text = JText::_('PLG_HIKASHOP_MOOJLA_COURSE_COMPLETED_RESTRICTION_MOOJLA_COURSES');
		$me->options = array('required', 'default', 'columnname', '', '', 'myuser_options');

		$fields[] = $me;

		$opt = new stdClass();
		$opt->name = 'myuser_options';
		$opt->text = JText::_('COURSES_OPTIONS');
		$opt->own_block = true;
		$opt->obj = 'fieldOpt_courses_options';

		$options[$opt->name] = $opt;

	}
    public function onBeforeCartSave(&$element, &$do)
    {
        $result = $this->check_course_status(end($element->cart_products)->product_id);

        if (!$result['status']) {
            $do = false;
            echo json_encode([
                'ret' => 0,
                'product_name' => $result['product_name'],
//                'message'=> JText::_('ONE_PORDUCT_ONE_PURCHASE_MESSAGE'),
                'message' => "ابتدا دروس {$result['moojla_courses']} را بگذرانید تا بتوانید این درس را تهیه کنید",
                'image' => JURI::base() . 'images/com_hikashop/upload/thumbnails/50x50/' . $result['image']
            ]);
            exit();
        }
        return true;
    }


    public function onBeforeOrderCreate(&$order, &$do)
    {
        $result = $this->check_course_status(end($order->cart->cart_products)->product_id);
        if (!$result['status'])
        {
            JFactory::getApplication()->enqueueMessage("ابتدا دروس {$result['moojla_courses']} را بگذرانید تا بتوانید این درس را تهیه کنید", 'message');
            $do= false;
        }
        return true;
    }


    public function check_course_status($product_id)
    {
        $product_class= hikashop_get('class.product');
        $user= JFactory::getUser();
        $userid= $user->get('id', 0);
        $product= $product_class->getProduct($product_id);
        $moojla_courses_that_must_be_completed= $product->moojla_courses;

        if (empty($moojla_courses_that_must_be_completed))
        {
            $result['status']= true;
            return  $result;

        }

        $result['status']= false;
        $result['product_name']= $product->product_name;

        $image= new stdClass();
        if (!empty($product->images))
            $image= current($product->images);
        else
            $image->file_path= 'barcode.png';

        $result['image']=  $image->file_path;
        $result['moojla_courses']= $moojla_courses_that_must_be_completed;
        return $result;
    }/***[/JCBGUI$$$$]***/

}
